//-- serializable.h
#ifndef SERIALIZABLE_H
#define SERIALIZABLE_H

#include <string>
#include <sstream>
#include <iostream>

struct Serializable{
  virtual std::string serialize() const = 0;
  
  template<class T>
  static std::string str(const T &t) {
    std::ostringstream str;
    str << t;
    return str.str();
  }
};

std::ostream &operator<<(std::ostream &str, const Serializable &s){
  return s << "???";
}

#endif
